<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT_SITE . "/lib/dompdf/autoload.inc.php");

use Dompdf\Dompdf;

class osmaControllerPreventivatore extends JControllerLegacy
{

    public function addCapitolo()
    {
        $input = JRequest::get("post");
        if($input['idCapitoloGenitore']) {
	        $dbo = JFactory::getDbo();
	        $query = $dbo->getQuery(true);
	        $query->select("livello")->from("#__osma_preventivatore_capitolato")->where("idCapitolo = {$input['idCapitoloGenitore']}");
	        $livelloGenitore = $dbo->setQuery($query)->loadResult();
	        $livello = $livelloGenitore + 1;
        } else {
	        $livello = 0;
		}

	   //var_dump($livelloGenitore);die();

        $obj = new stdClass();
        $obj->idCapitoloGenitore = $input['idCapitoloGenitore'];
	    $obj->livello = $livello;
        $obj->descrizione = $input['descrizione'];
        $obj->codiceCapitolo = $input['codiceCapitolo'];
        $obj->prezziario = $input['prezziario'];
        $obj->nome = $input['nome'];
        $obj->um = $input['um'];
        $obj->prezzoUnitario = $input['prezzoUnitario'];

        if ($input['idCapitolo']) {
            $obj->idCapitolo = $input['idCapitolo'];
            JFactory::getDbo()->updateObject('#__osma_preventivatore_capitolato', $obj, 'idCapitolo');
        } else {
            JFactory::getDbo()->insertObject('#__osma_preventivatore_capitolato', $obj, 'idCapitolo');
        }

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function removeCapitolo()
    {
        $id = JRequest::getVar("id");

        if (!$id) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("idCapitolo = {$id}");
        $result = $dbo->setQuery($query)->loadObject();

        $oldIDCapitolo = $result->idCapitolo;
        $newIDCapitolo = $result->idCapitoloGenitore;

        $dbo->setQuery("DELETE FROM #__osma_preventivatore_capitolato WHERE idCapitolo = {$id}")->execute();
        $dbo->setQuery("UPDATE #__osma_preventivatore_capitolato SET idCapitoloGenitore = {$newIDCapitolo} WHERE idCapitoloGenitore = {$oldIDCapitolo}")->execute();

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function getCapitolo()
    {
        $id = JRequest::getVar("id");

        if (!$id) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("idCapitolo = {$id}");
        $obj = $dbo->setQuery($query)->loadObject();
        $obj->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($obj);

        echo new JResponseJson($obj, null);
        JApplication::close();
    }

    public function getCapitoliChildren()
    {
        $id = JRequest::getVar("id");
        $q = JRequest::getVar("q");

        if (!$id && !$q) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->order("livello ASC");

        if ($id) {
            $query->where("idCapitoloGenitore = {$id}");
        }
        if ($q) {
            $query->where("(nome LIKE '%" . $q . "%' or descrizione LIKE '%" . $q . "%')");
        }

        $objectL = $dbo->setQuery($query)->loadObjectList();

        foreach ($objectL as $item) {
            $item->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($item);
        }

        echo new JResponseJson($objectL, null);
        JApplication::close();
    }

    public function getFiltersValues()
    {
        $id = JRequest::getVar("id");
        $livello = JRequest::getVar("livello");

        if ($livello == NULL) {
            $livello = 0;
        }

        if (!$id)
            $id = "";

        $dbo = JFactory::getDbo();


        switch ($livello) {
            case -1:
                $listinoSel = "";
                $capitoloSel = "";
                $famigliaSel = "";
                $voceSel = "";
                $sottoVoceSel = "";
                break;
            case 0:
                $listinoSel = $id;
                $capitoloSel = "";
                $famigliaSel = "";
                $voceSel = "";
                $sottoVoceSel = "";

                break;

            case 1:
                $capitoloSel = $id;

                //trovo dati
                $query = $dbo->getQuery(true);
                $query->select('idCapitoloGenitore,prezziario')->from('#__osma_preventivatore_capitolato')->order('codiceCapitolo ASC');
                if ($capitoloSel != "")
                    $query->where('idCapitolo=' . $capitoloSel);
                $data = $dbo->setQuery($query)->loadObject();
                //trovo listino
                $listinoSel = $data->prezziario;


                $famigliaSel = "";
                $voceSel = "";
                $sottoVoceSel = "";


                break;

            case 2:
                $famigliaSel = $id;

                //trovo dati
                $query = $dbo->getQuery(true);
                $query->select('idCapitoloGenitore,prezziario')->from('#__osma_preventivatore_capitolato')->order('codiceCapitolo ASC');
                if ($famigliaSel != "")
                    $query->where('idCapitolo=' . $famigliaSel);
                $data = $dbo->setQuery($query)->loadObject();

                //trovo listino
                $listinoSel = $data->prezziario;

                //trovo capitolo
                $capitoloSel = $data->idCapitoloGenitore;

                break;

            case 3:
                $voceSel = $id;

                //trovo dati
                $query = $dbo->getQuery(true);
                $query->select('idCapitoloGenitore,prezziario,prezzoUnitario,um')->from('#__osma_preventivatore_capitolato')->order('codiceCapitolo ASC');
                if ($voceSel != "")
                    $query->where('idCapitolo=' . $voceSel);
                $data = $dbo->setQuery($query)->loadObject();

                //trovo listino
                $listinoSel = $data->prezziario;

                //trovo capitolo
                $famigliaSel = $data->idCapitoloGenitore;

                //trovo prezzoUnitario e um
                $vocePrezzoUnitarioSel = $data->prezzoUnitario;
                $voceUmSel = $data->um;

                $query = $dbo->getQuery(true);
                $query->select('idCapitoloGenitore')->from('#__osma_preventivatore_capitolato')->where('idCapitolo=' . $famigliaSel)->order('codiceCapitolo ASC');
                $capitoloSel = $dbo->setQuery($query)->loadResult();


                break;

            case 4:
                $sottoVoceSel = $id;

                //trovo dati
                $query = $dbo->getQuery(true);
                $query->select('idCapitoloGenitore,prezziario,prezzoUnitario,um')->from('#__osma_preventivatore_capitolato')->order('codiceCapitolo ASC');
                if ($sottoVoceSel != "")
                    $query->where('idCapitolo=' . $sottoVoceSel);
                $data = $dbo->setQuery($query)->loadObject();

                //trovo listino
                $listinoSel = $data->prezziario;

                //trovo voce
                $voceSel = $data->idCapitoloGenitore;

                //trovo prezzoUnitario e um
                $sottoVocePrezzoUnitarioSel = $data->prezzoUnitario;
                $sottoVoceUmSel = $data->um;

                //trovo famiglia
                $query = $dbo->getQuery(true);
                $query->select('idCapitoloGenitore')->from('#__osma_preventivatore_capitolato')->where('idCapitolo=' . $voceSel)->order('codiceCapitolo ASC');
                $famigliaSel = $dbo->setQuery($query)->loadResult();

                //trovo capitolo
                $query = $dbo->getQuery(true);
                $query->select('idCapitoloGenitore')->from('#__osma_preventivatore_capitolato')->where('idCapitolo=' . $famigliaSel)->order('codiceCapitolo ASC');
                $capitoloSel = $dbo->setQuery($query)->loadResult();

                break;
        }

        if ($listinoSel == "") {
            $famiglie="";
            $voci="";
            $sottoVoci="";
            $listinoSel="";
            $capitoloSel="";
            $famigliaSel="";
            $voceSel="";
            $sottoVoceSel="";
        } else {

            //valori tendina capitolo
            $query = $dbo->getQuery(true);
            $query->select('idCapitolo,codiceCapitolo,nome,descrizione,livello')->from('#__osma_preventivatore_capitolato')->where('livello=1')->order('codiceCapitolo ASC');
            if ($listinoSel && $listinoSel != "")
                $query->where('idCapitoloGenitore=' . $listinoSel);

            $objectL['capitoli']['values'] = $dbo->setQuery($query)->loadObjectList();

            //trovo famiglie
            $query = $dbo->getQuery(true);
            $query->select('idCapitolo,codiceCapitolo,nome,descrizione,livello')->from('#__osma_preventivatore_capitolato')->where('livello=2')->where('prezziario=' . $listinoSel)->order('codiceCapitolo ASC');

            if ($capitoloSel && $capitoloSel != "")
                $query->where('idCapitoloGenitore=' . $capitoloSel);

            $famiglie = $dbo->setQuery($query)->loadObjectList();

            if (!$famigliaSel || $famigliaSel == "") {
                foreach ($famiglie as $key => $famiglia) {
                    //trovo voci
                    $query = $dbo->getQuery(true);
                    $query->select('idCapitolo,codiceCapitolo,nome,descrizione,prezzoUnitario,um,livello')->from('#__osma_preventivatore_capitolato')->where('livello=3')->where('prezziario=' . $listinoSel)->order('codiceCapitolo ASC');

                    $query->where('idCapitoloGenitore=' . $famiglia->idCapitolo);
                    $data = $dbo->setQuery($query)->loadObjectList();

                    $voci[$key] = $data;

                }

            } else {
                $query = $dbo->getQuery(true);
                $query->select('idCapitolo,codiceCapitolo,nome,descrizione,prezzoUnitario,um,livello')->from('#__osma_preventivatore_capitolato')->where('livello=3')->where('prezziario=' . $listinoSel)->where('idCapitoloGenitore=' . $famigliaSel)->order('codiceCapitolo ASC');
                $voci[0] = $dbo->setQuery($query)->loadObjectList();


            }

            if ($voceSel && $voceSel != "") {
                $query = $dbo->getQuery(true);
                $query->select('idCapitolo,codiceCapitolo,nome,descrizione,prezzoUnitario,um,livello')->from('#__osma_preventivatore_capitolato')->where('livello=4')->where('prezziario=' . $listinoSel)->order('codiceCapitolo ASC');
                $query->where('idCapitoloGenitore=' . $voceSel);
                $sottoVoci[0] = $dbo->setQuery($query)->loadObjectList();

            } else {
                if ($livello == 3) {
                    foreach ($voci as $voce) {

                        //trovo sottovoci
                        $query = $dbo->getQuery(true);
                        $query->select('idCapitolo,codiceCapitolo,nome,descrizione,prezzoUnitario,um,livello')->from('#__osma_preventivatore_capitolato')->where('livello=4')->where('prezziario=' . $listinoSel)->order('codiceCapitolo ASC');

                        if ($voce->idCapitolo)
                            $query->where('idCapitoloGenitore=' . $voce->idCapitolo);
                        $sottoVoci[] = $dbo->setQuery($query)->loadObjectList();

                    }
                }

            }

        }

        $objectL['famiglie']['values'] = $famiglie;
        $objectL['voci']['values'] = $voci;
        $objectL['sottovoci']['values'] = $sottoVoci;


        $objectL['listini']['selected'] = $listinoSel;
        $objectL['capitoli']['selected'] = $capitoloSel;
        $objectL['famiglie']['selected'] = $famigliaSel;
        $objectL['voci']['selected'] = $voceSel;
        $objectL['sottovoci']['selected'] = $sottoVoceSel;

        //print_r($objectL);die();

        echo new JResponseJson($objectL, null);
        JApplication::close();

        /*$dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("um != '' AND um IS NOT NULL")->order("codiceCapitolo, nome");

        if ($id) {
            $query->where("idCapitoloGenitore = {$id}");
        }
        if ($q) {
            $query->where("(nome LIKE '%" . $q . "%' or descrizione LIKE '%" . $q . "%')");
        }

        $objectL = $dbo->setQuery($query)->loadObjectList();

        foreach ($objectL as $item) {
            $item->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($item);
        }

        echo new JResponseJson($objectL, null);
        JApplication::close();*/
    }
    public function descrizioneVoce(){

        $id = JRequest::getVar("id");
        $livello = JRequest::getVar("livello");
        $dbo = JFactory::getDbo();

        if($livello=="4"){
            $query = $dbo->getQuery(true);
            $query->select("idCapitoloGenitore")->from("#__osma_preventivatore_capitolato")->where("idCapitolo=".$id);
            $idCapitoloGenitore = $dbo->setQuery($query)->loadResult();

            if($idCapitoloGenitore>0){
                $query = $dbo->getQuery(true);
                $query->select("descrizione")->from("#__osma_preventivatore_capitolato")->where("idCapitolo=".$idCapitoloGenitore);
                $descrizione = $dbo->setQuery($query)->loadResult();
            }

            echo new JResponseJson($descrizione, null);
            JApplication::close();
        }
    }

    public function calcolaTotale()
    {
        $post = JRequest::get('post');

        $preventivo = array();
        $lordo = 0;
        $finale = 0;
        if ($post) {
            foreach ($post['idCapitolo'] as $k => $idCapitolo) {
                $preventivo[] = (object)array(
                    'quantita' => $post['quantita'][$k],
                    'prezzoUnitario' => $post['prezzoUnitario'][$k],
                    'sconto' => $post['sconto'][$k],
                );
            }
        }


        foreach ($preventivo as $row) {
            $totale = $row->quantita * $row->prezzoUnitario;
            $valoreS = ($totale / 100) * $row->sconto;
            $totalescontato = round($totale - $valoreS, 2);

            $finale += $totalescontato;
            $lordo += $totale;
        }

        echo new JResponseJson(array('lordo' => number_format($lordo, 2, ",", "."), 'lavori' => number_format($finale, 2, ",", ".")), null);
        JApplication::close();
    }

    public function aggiungiPreventivo()
    {

        $post = JRequest::get('post');
        if (!$post['idCapitolo']) {

        }

        $dbo = JFactory::getDbo();

        $obj = new stdClass();
        $obj->note = JRequest::getVar("note");
        if (JRequest::getVar("idPreventivo")) {
            $idPreventivo = JRequest::getVar("idPreventivo");
            $obj->idPreventivo = $idPreventivo;
            $dbo->updateObject("#__osma_preventivatore_preventivi", $obj, 'idPreventivo');
        } else {
            $obj->idChiamata = JRequest::getVar("idChiamata");
            $dbo->insertObject("#__osma_preventivatore_preventivi", $obj);

            $idPreventivo = $dbo->insertid();

            $dbo->setQuery("UPDATE #__osma_chiamate SET consuntivata = 1 WHERE idChiamata = " . $obj->idChiamata)->execute();
        }

        $dbo->setQuery("DELETE FROM #__osma_preventivatore_preventivi_voci WHERE idPreventivo = " . $idPreventivo)->execute();

        foreach ($post['idCapitolo'] as $k => $idCapitolo) {
            $voce = new stdClass();
            $voce->idCapitolo = $idCapitolo;
            $voce->prezzoUnitario = $post['prezzoUnitario'][$k];
            $voce->quantita = $post['quantita'][$k];
            $voce->nome = $post['nome'][$k];
            $voce->um = $post['um'][$k];
            $voce->sconto = $post['sconto'][$k];
            $voce->note = $post['noteVoci'][$k];
            $voce->orderId=$post['orderId'][$k];
            $voce->idPreventivo = $idPreventivo;
            $dbo->insertObject("#__osma_preventivatore_preventivi_voci", $voce);
        }

        JFactory::getApplication()->redirect(osmaHelper::router("index.php?option=com_osma&view=preventivatore&layout=preventivo&idPreventivo=" . $idPreventivo), 'Preventivo salvato correttamente');
    }

    public function inviaPreventivo()
    {
        $indirizzi = JRequest::getVar('indirizzi');

        if (!$indirizzi) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $to = array();
        foreach ($indirizzi as $field) {
            $explode = explode(",", $field);
            foreach ($explode as $email) {
                $email = trim($email);
                if (filter_var($email, FILTER_VALIDATE_EMAIL) !== false) {
                    $to[] = filter_var($email, FILTER_VALIDATE_EMAIL);
                }
            }
        }
        if (!$to) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();

        $preventivo = $dbo->setQuery("SELECT * FROM #__osma_preventivatore_preventivi WHERE idPreventivo = " . JRequest::getVar("idPreventivo"))->loadObject();
        $chiamata = $dbo->setQuery("SELECT * FROM #__osma_chiamate WHERE idChiamata = " . $dbo->q($preventivo->idChiamata))->loadObject();

        $config = JFactory::getConfig();
        $mailer = JFactory::getMailer();
        $mailer->setSender(array(
            $config->get('mailfrom'),
            $config->get('fromname')
        ));
        $mailer->setSubject('Invio preventivo nr. ' . str_pad($preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) . "/" . date("Y", strtotime($preventivo->inserted)) . " - Rif. chiamata: " . $chiamata->nrChiamata . ' da OSMA SNC');
        $mailer->setBody("In allegato trovate preventivo nr. " . str_pad($preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) . "/" . date("Y", strtotime($preventivo->inserted)) . " - Rif. chiamata: " . $chiamata->nrChiamata . " da OSMA SNC. Si prega di inviarlo compilato in ogni sua parte all'indirizzo email " . COM_OSMA_MAIL_UFFICIO);

        if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
            $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
        }

        foreach ($to as $mail) {
            if (trim($mail)) {
                $mailer->addRecipient(trim($mail));
            }
        }

        $ida = uniqid() . time();
      	$this->stampaPreventivo($preventivo->idPreventivo,$ida);
	    //var_dump('ciao');die();
        $mailer->addAttachment(JPATH_COMPONENT . "/tmp/{$ida}.pdf");

        if ($mailer->Send() !== true) {
            mailerHelper::logMail($mailer, 7, false, $preventivo->idPreventivo);
            echo new JResponseJson(null, "Errore", true);
        } else {
            mailerHelper::logMail($mailer, 7, true, $preventivo->idPreventivo);
            echo new JResponseJson(null, null);
        }

       // unlink(JPATH_COMPONENT . "/tmp/{$ida}.pdf");
        JApplication::close();
    }

    public function stampaPreventivo($idPreventivo=null,$ida=null)
    {
    	if(!$idPreventivo) {
		    $idPreventivo = JRequest::getVar("idPreventivo");
	    }
	    if(!$ida) {
        	$ida = JRequest::getVar("ida");
	    }
        $dbo = JFactory::getDbo();


        $preventivo = $dbo->setQuery("SELECT * FROM #__osma_preventivatore_preventivi WHERE idPreventivo = " . $dbo->q($idPreventivo))->loadObject();
        $preventivo->voci = $dbo->setQuery("SELECT v.*, c.idCapitoloGenitore, c.codiceCapitolo FROM #__osma_preventivatore_preventivi_voci v LEFT OUTER JOIN #__osma_preventivatore_capitolato c ON c.idCapitolo = v.idCapitolo WHERE idPreventivo = " . $dbo->q($preventivo->idPreventivo)." ORDER BY v.orderId")->loadObjectList();
        $chiamata = $dbo->setQuery("SELECT * FROM #__osma_chiamate WHERE idChiamata = " . $dbo->q($preventivo->idChiamata))->loadObject();
        $cliente = $dbo->setQuery("SELECT * FROM #__osma_anagrafica_clienti WHERE idCliente = " . $dbo->q($chiamata->idCliente))->loadObject();
        $gestore = $dbo->setQuery("SELECT * FROM #__osma_anagrafica_gestori WHERE idGestore = " . $dbo->q($chiamata->idGestore))->loadObject();

        foreach ($preventivo->voci as $item) {
            $item->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($item);
            $totale = $item->prezzoUnitario * $item->quantita;
            $item->totale = round($totale, 2);

            $valoreS = ($totale / 100) * $item->sconto;
            $valore = $totale - $valoreS;
            $item->importo = round($valore, 2);

            $preventivo->totaleLavori += $totale;
            $preventivo->totalePreventivo += $valore;
        }

        $preventivo->totaleLavori = round($preventivo->totaleLavori, 2);
        $preventivo->totalePreventivo = round($preventivo->totalePreventivo, 2);

        ob_start();
        require_once(JPATH_COMPONENT_SITE . "/templates/pdf/preventivatore-preventivo.php");
        $result = ob_get_clean();

        $dompdf = new Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();
        if($ida) {
	        $output = $dompdf->output();
	        file_put_contents(JPATH_COMPONENT . "/tmp/{$ida}.pdf", $output);
		} else {
	        $dompdf->stream("preventivo-" . str_pad($preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) . "-" . date("Y", strtotime($preventivo->inserted)) . "-" . time());
	        exit;
        }

    }

    public function getVociPreventivo()
    {

        $dbo = JFactory::getDbo();
        $voci = $dbo->setQuery("SELECT v.*, c.idCapitoloGenitore, c.codiceCapitolo FROM #__osma_preventivatore_preventivi_voci v LEFT OUTER JOIN #__osma_preventivatore_capitolato c ON c.idCapitolo = v.idCapitolo WHERE idPreventivo = " . $dbo->q(JRequest::getVar("idPreventivo")))->loadObjectList();

        ob_start();
        foreach ($voci as $item) {
            $item->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($item);
            ?>
            <div class="clearfix" style="padding-top: 7.5px; padding-bottom: 7.5px;">
                <div class="col-sm-1 text-left">
                    <input type="checkbox" name="idVoce[]" value="<?php echo $item->idVoce ?>"/>
                </div>
                <div class="col-sm-4 text-left">
                    <div class="row"
                         style='max-width: 100%; white-space: nowrap; text-overflow: ellipsis; overflow: hidden;'>
                        <?php echo $item->codiceCapitoloRaw ? $item->codiceCapitoloRaw : "-" ?>
                    </div>
                </div>
                <div class="col-sm-6 text-left" style="">
                    <div class="row"
                         style='max-width: 100%; white-space: nowrap; text-overflow: ellipsis; overflow: hidden;'>
                        <?php echo $item->nome ?>
                        <?php if($item->note && $item->note!=""){?>
                            <br /><small><strong style="">Note: </strong><?php echo $item->note;?></small>
                        <?php } ?>
                    </div>
                </div>
            </div>
            <?php
        }

        echo new JResponseJson(ob_get_clean(), null);
        JApplication::close();
    }

    public function copiaVoci()
    {
        parse_str(JRequest::getVar('copia'), $copia);

        if (!$copia['idVoce']) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $obj = new stdClass();
        $obj->note = JRequest::getVar("note");
        if (JRequest::getVar("idPreventivo")) {
            $idPreventivo = JRequest::getVar("idPreventivo");
            $obj->idPreventivo = $idPreventivo;
            $dbo->updateObject("#__osma_preventivatore_preventivi", $obj, 'idPreventivo');
        } else {
            $obj->idChiamata = JRequest::getVar("idChiamata");
            $dbo->insertObject("#__osma_preventivatore_preventivi", $obj);

            $idPreventivo = $dbo->insertid();

            $dbo->setQuery("UPDATE #__osma_chiamate SET consuntivata = 1 WHERE idChiamata = " . $obj->idChiamata)->execute();
        }

        //controllo che non ci siano già voci a database
        if (JRequest::getVar("idPreventivo")) {
            $query = $dbo->getQuery(true);

            $query->select('MAX(orderId) as m')->from('#__osma_preventivatore_preventivi_voci')->where('idPreventivo='.$idPreventivo);
            $dbo->setQuery($query);
            $next= $dbo->loadResult();
            $next=$next+1;
        }else{
            $next=0;
        }

        $dbo->setQuery("INSERT INTO #__osma_preventivatore_preventivi_voci (idPreventivo, idCapitolo, nome, prezzoUnitario, quantita, um, sconto, note) SELECT " . $idPreventivo . ", idCapitolo, nome, prezzoUnitario, quantita, um, sconto, note FROM #__osma_preventivatore_preventivi_voci WHERE idVoce IN (" . implode(",", $copia['idVoce']) . ")");
        $dbo->execute();

        //trovo tutte le voci nuove inserite e aggiorno ordinamento
        $query = $dbo->getQuery(true);
        $query->select('*')->from('#__osma_preventivatore_preventivi_voci')->where('idPreventivo='.$idPreventivo);
        $dbo->setQuery($query);
        $voci=$dbo->loadObjectList();

        foreach ($voci as $voce){
            $object = new stdClass();
            $object->idVoce=$voce->idVoce;
            $object->orderId=$next;
            $dbo->updateObject('#__osma_preventivatore_preventivi_voci', $object, 'idVoce');
            $next++;
        }

        echo new JResponseJson(osmaHelper::router("index.php?option=com_osma&view=preventivatore&layout=preventivo&idPreventivo=" . $idPreventivo), null);
        JApplication::close();
    }

    public function modificaVocePreventivo(){
        $model = $this->getModel('preventivatore');
        $model->modificaVocePreventivo();
    }
    public function eliminaVocePreventivo(){
        $idPreventivo=JRequest::getVar("idPreventivo");
        $model = $this->getModel('preventivatore');
        $model->eliminaVocePreventivo();

        JFactory::getApplication()->redirect(osmaHelper::router("index.php?option=com_osma&view=preventivatore&layout=preventivo&idPreventivo=" . $idPreventivo), 'Voce eliminata correttamente');
        JApplication::close();
    }

    public function ordinaVociPreventivo(){
        $model = $this->getModel('preventivatore');
        $model->ordinaVociPreventivo();
    }

    public function salvaVoce(){
        $model = $this->getModel('preventivatore');
        $id=$model->salvaVoce();

        echo $id;
    }
}
