<form id="add" class="addmanutentore">
    <div class="row">
        <div class="form-group col-md-12">
            <div class="control-group has-icon">
                <input type="text" class="obb name form-control has-icon-left" name="name" placeholder="Cognome e Nome" value="<?php echo $data->name; ?>"/>
                <i class="fa fa-user control-group-icon"></i>
            </div>
        </div>
        <div class="form-group col-md-4">
            <div class="control-group has-icon">
                <input type="text" class="obb telefono form-control has-icon-left" name="telefono" placeholder="Telefono" value="<?php echo $data->telefono; ?>"/>
                <i class="fa fa-phone control-group-icon"></i>
            </div>
        </div>
        <div class="form-group col-md-4">
            <div class="control-group has-icon">
                <input type="text" class="obb costo form-control has-icon-left" name="costoOrario" placeholder="Costo / Ora" value="<?php echo $data->costoOrario; ?>"/>
                <i class="fa fa-eur control-group-icon"></i>
            </div>
        </div>
        <div class="form-group col-md-4">
            <div class="control-group has-icon datetimepicker input-group date">
                <i class="fa fa-calendar control-group-icon input-group-addon"></i>
                <input type="text" class="obb costo form-control has-icon-left" name="scadenzaVisita" placeholder="Scadenza visita" value="<?php echo (strtotime($data->scadenzaVisita) ? date("d/m/Y", strtotime($data->scadenzaVisita)) : null); ?>"/>
            </div>
        </div>
        <div class="form-group col-md-6">
            <div class="control-group has-icon">
                <input type="email" class="obb email form-control has-icon-left" name="email" placeholder="Email" value="<?php echo $data->email; ?>" required="required"/>
                <i class="fa fa-envelope control-group-icon"></i>
            </div>
        </div>
        <div class="form-group col-md-6">
            <div class="control-group has-icon">
                <input type="password" class="obb password form-control has-icon-left" name="password" placeholder="Password" />
                <i class="fa fa-lock control-group-icon"></i>
            </div>
        </div>
        <div class="form-group col-md-12">
            <div class="control-group has-icon">
                <select name="idMezzo" data-placeholder="Associa al mezzo" class="mezzo-select has-icon-left" tabindex="17" style="width:100%;">
                    <option value="0" <?php echo(!$data->idMezzo ? "selected='selected'" : null) ?> disabled>Associa al mezzo</option>
                    <?php foreach ($mezzi as $mezzo) { ?>
                        <option <?php echo($mezzo->idMezzo == $data->idMezzo ? "selected='selected'" : null) ?> value="<?php echo $mezzo->idMezzo; ?>"><?php echo $mezzo->marca . " | " . $mezzo->modello . " | " . $mezzo->targa; ?></option>
                    <?php } ?>
                </select>
                <i class="fa fa-car control-group-icon"></i>
            </div>
        </div>
        <input type="hidden" name="idUser" value="<?php echo JRequest::getVar('idUser'); ?>" id="idUser" />
    </div>
    <script>
        jQuery('.datetimepicker').datetimepicker({
            format: 'DD/MM/YYYY'
        });
    </script>
</form>
