<?php
defined('_JEXEC') or die('Restricted access');
?>


<div class="t3a-toolbar row">
    <div class="clearfix hidden-xs flex" style="align-items: center;">
        <?php echo $this->loadTemplate('form'); ?>
    </div>
    <div class="visible-xs col-xs-12 text-center"style="padding-top: 15px; padding-bottom: 15px">
        <a href="#filter-collapse" data-toggle="collapse" role="button" aria-expanded="false" aria-controls="filter-collapse"><i class="glyphicon glyphicon-filter"></i> Azioni e filtri</a>        
    </div>
    <div class="col-xs-12 collapse" id="filter-collapse">
        <?php echo $this->loadTemplate('form'); ?>
    </div>
</div>

<form action="<?php echo JRoute::_('index.php?option=com_osma&view=fornitori'); ?>" method="post" id="adminForm" class="form-validate" name="fornitoriForm">
    <div class="panel panel-default main-panel" id="chiamate-print">
        <div class="panel-heading">
            <h3 class="panel-title">Anagrafica fornitori</h3>
        </div>
        <div class="panel-body">
            <div class="table-responsive">
                <table class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>Ragione Sociale</th>
                            <th>Indirizzo</th>
                            <th>Comune</th>
                            <th>Prov.</th>
                            <th>CAP</th>
                            <th>PIVA</th>
                            <th>CF</th>
                            <th>Riferimenti</th>
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                            <td colspan="9" class="t3a-pagination">
                                <div class="col-md-6 text-left"><?php echo $this->pagination->getListFooter(); ?></div>
                                <div class="col-md-6 text-right">Nr. Risultati: <?php echo $this->pagination->getLimitBox(); ?></div>
                            </td>
                        </tr>
                    </tfoot>
                    <tbody>
                        <?php if (!empty($this->fornitori)) { ?>
                            <?php $i = 0; ?>
                            <?php foreach ($this->fornitori as $i => $fornitore) { ?>
                                <?php $checked = JHTML::_('grid.id', $i++, $fornitore->idFornitore); ?>
                                <tr>
                                    <td align="center"><?php echo $checked; ?></td>
                                    <td><?php echo $fornitore->ragioneSociale; ?></td>
                                    <td><?php echo $fornitore->indirizzo; ?></td>
                                    <td><?php echo $fornitore->comune; ?></td>
                                    <td><?php echo $fornitore->provincia; ?></td>
                                    <td><?php echo $fornitore->cap; ?></td>
                                    <td><?php echo $fornitore->piva; ?></td>
                                    <td><?php echo $fornitore->cf; ?></td>
                                    <td class="center"><button data-toggle="modal" data-target="#viewContatcts" data-idFornitore="<?php echo $fornitore->idFornitore; ?>" class="btn btn-default btn-sm contact-btn"><span class="glyphicon glyphicon-earphone"></span></button></td>
                                </tr>
                            <?php } //end foreach ?>
                            <? }else{ ?>
                        <td colspan="9">Nessun fornitore inserito.</td>
                    <?php } //end if empty?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <input type="hidden" name="task" value=""/>
    <input type="hidden" name="boxchecked" value="0"/>
    <?php echo JHtml::_('form.token'); ?>
</form>
<div class="modal fade bs-example-modal-lg" id="addFornitore" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="myModalLabel">Dati fornitore</h4>
            </div>
            <div class="modal-body">
                ...
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Chiudi</button>
            </div>
        </div>
    </div>
</div>
<div class="modal fade bs-example-modal-lg" id="viewContacts" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="myModalLabel">Contatti</h4>
            </div>
            <div class="modal-body">
                ...
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Chiudi</button>
            </div>
        </div>
    </div>
</div>
<script type="text/javascript">
//nuovo
    jQuery(document).on('click', '.nuovo', function (event) {
        event.preventDefault();

        var idFornitore = jQuery(this).attr('data-idFornitore');
        jQuery('#addFornitore').find(".modal-body").load('index.php?option=com_osma&task=fornitori.addfornitoriform&format=raw&id=' + idFornitore);
        jQuery('#addFornitore').find(".modal-footer").html('<button type="button" class="btn btn-default" data-dismiss="modal">Chiudi</button><button type="button" class="btn btn-primary salvabtn">Salva</button>');
        jQuery('#addFornitore').modal();

        return false;
    });

//Modifica
    jQuery(document).on('click', '.modifica', function (event) {
        event.preventDefault();

        var checked = true;
        var idFornitore = "";
        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                checked = true;
                idFornitore = jQuery(value).val();
                return false;
            } else {
                checked = false;
            }
        });
        if (checked == true) {
            jQuery('#addFornitore').find(".modal-body").load('index.php?option=com_osma&task=fornitori.addfornitoriform&format=raw&id=' + idFornitore);
            jQuery('#addFornitore').find(".modal-footer").html('<button type="button" class="btn btn-default" data-dismiss="modal">Chiudi</button><button type="button" class="btn btn-primary salvabtn">Salva</button>');
            jQuery('#addFornitore').modal();
        } else {
            var msg = {
                error: ['Seleziona almeno un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//Pubblica
    jQuery(document).on('click', '.pubblica', function (event) {
        event.preventDefault();

        var i = 0;
        var ids = [];

        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                ids.push(jQuery(value).val());
            }
        });
        if (ids.length != 0) {
            //ajax call
            var url = "index.php?option=com_osma&task=fornitori.pubblica&format=raw";
            jQuery.ajax({
                type: "POST",
                url: url,
                data: {ids: ids, type: 2
                }
            }).done(function (result) {
                var msg = {
                    success: ['Pubblicazione degli elementi selezionati avvenuta con successo.']
                };
                Joomla.renderMessages(msg);
            });
        } else {
            var msg = {
                error: ['Seleziona almeno un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//Sospendi
    jQuery(document).on('click', '.sospendi', function (event) {
        event.preventDefault();

        var i = 0;
        var ids = [];

        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                ids.push(jQuery(value).val());
            }
        });
        if (ids.length != 0) {
            //ajax call
            var url = "index.php?option=com_osma&task=fornitori.sospendi&format=raw";
            jQuery.ajax({
                type: "POST",
                url: url,
                data: {ids: ids, type: 2
                }
            }).done(function (result) {
                var msg = {
                    success: ['Sospensione degli elementi selezionati avvenuta con successo.']
                };
                Joomla.renderMessages(msg);
                setInterval(function () {
                    refresh()
                }, 3000);
            });
        } else {
            var msg = {
                error: ['Seleziona almeno un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//Rimuovi
    jQuery(document).on('click', '.rimuovi', function (event) {
        event.preventDefault();

        var i = 0;
        var ids = [];

        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                ids.push(jQuery(value).val());
            }
        });
        if (ids.length != 0) {
            //chiedo conferma della Rimozione
            var r = confirm("Sei sicuro di voler eliminare gli elementi selezionati?");
            if (r == true) {
                var url = "index.php?option=com_osma&task=fornitori.rimuovi&format=raw";
                jQuery.ajax({
                    type: "POST",
                    url: url,
                    data: {ids: ids, type: 2
                    }
                }).done(function (result) {
                    jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
                        if (jQuery(value).attr("checked")) {
                            el = jQuery(value);
                            el.parent().parent().remove();
                        }
                    });
                    var msg = {
                        success: ['Rimozione degli elementi selezionati avvenuta con successo.']
                    };
                    Joomla.renderMessages(msg);
                    setInterval(function () {
                        refresh()
                    }, 3000);
                });
            } else {
                return false;
            }
        } else {
            var msg = {
                error: ['Seleziona almeno un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//visualizza contatti
    jQuery(document).on('click', '.contact-btn', function (event) {
        event.preventDefault();
        event.stopImmediatePropagation();
        event.stopPropagation();

        var idFornitore = jQuery(this).attr('data-idFornitore');
        jQuery('#viewContacts').find(".modal-body").load('index.php?option=com_osma&task=fornitori.viewcontatti&format=raw&type=2&id=' + idFornitore);
        jQuery('#viewContacts').find(".modal-footer").html('<button type="button" class="btn btn-default" data-dismiss="modal">Chiudi</button>');
        jQuery('#viewContacts').modal();

        return false;
    });

//salvataggio dati fornitore
    jQuery(document).on('click', '.salvabtn', function (event) {
        event.preventDefault();
        var inviaForm = 0;
        var ragioneSociale = jQuery('.ragionesociale').val();

        if (ragioneSociale == "") {
            jQuery('.ragionesociale').parent().addClass("has-error");
            jQuery('.ragionesociale').parent().find('span').removeClass("hidden");
            inviaForm = 0;
        } else {
            jQuery('.ragionesociale').parent().removeClass("has-error");
            jQuery('.ragionesociale').parent().addClass("has-success");
            jQuery('.ragionesociale').parent().find('span').addClass("hidden");
            inviaForm = 1
        }

        if (inviaForm == 1) {
            var addfornitoreformfield = jQuery('#add').serialize();

            jQuery.ajax({
                type: 'POST',
                url: 'index.php?option=com_osma&task=fornitori.salva&format=raw&tmpl=component&type=2',
                data: addfornitoreformfield,
                dataType: 'html'
            }).done(function (data) {
                if (data == 'error') {
                    jQuery('#addFornitore').modal('toggle');
                    var msg = {
                        error: ['Errore nel salvataggio dei dati.']
                    };
                    Joomla.renderMessages(msg);
                    setInterval(function () {
                        refresh()
                    }, 3000);
                } else {
                    jQuery('#addFornitore').modal('toggle');
                    var msg = {
                        success: ['Salvataggio dati avvenuto con successo.']
                    };
                    Joomla.renderMessages(msg);
                    setInterval(function () {
                        refresh()
                    }, 3000);
                }
            });
        }

        return false;
    });

//aggiunta nuovo contatto
    jQuery(document).on('click', '.nuovoContatto', function (event) {
        event.preventDefault();

        el = jQuery(this);
        var count = el.attr('data-rowcount');
        count = parseFloat(count) + 1;

        var html = '';
        html += '<div class="panel panel-warning">';
        html += '<div class="panel-body">';
        html += '<div class="row">';
        html += '<div class="form-group col-md-10">';
        html += '<input type="text" class="riferimento form-control" name="contatti[' + count + '][riferimento]" id="riferimento' + count + '" placeholder="Riferimento" value=""/>';
        html += '</div>';
        html += '<div class="form-group col-md-2">';
        html += '<button class="btn btn-danger btn-sm remove-btn pull-right"><span class="glyphicon glyphicon-remove"></span></button>';
        html += '</div>';
        html += '<div class="form-group col-md-6">';
        html += '<input type="text" class="email form-control" name="contatti[' + count + '][email]" id="email' + count + '" placeholder="Email" value=""/>';
        html += '</div>';
        html += '<div class="form-group col-md-6">';
        html += '<input type="text" class="telefono form-control" name="contatti[' + count + '][telefono]" id="telefono' + count + '" placeholder="Telefono" value=""/>';
        html += '</div>';
        html += '</div>';
        html += '</div>';
        html += '</div>';

        jQuery('.contatti-group').append(html);
        el.attr('data-rowcount', count);
    });
//aggiunta nuovo contatto
    jQuery(document).on('click', '.remove-btn', function (event) {
        event.preventDefault();
        el = jQuery(this).parent().parent().parent().parent().remove();
    });
//refresh page dopo aver mostrato il messaggio di salvataggio
    function refresh() {
        window.location.reload(true);
    }
</script>
