<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

$user = JFactory::getUser();
$userid = $user->get('id');

$canEdit = !osmaHelper::isAccessLevel(COM_OSMA_AL_UTENZE) || (osmaHelper::isAccessLevel(COM_OSMA_AL_UTENZE) && !$this->chiamata->interventi);
?>
<div class="t3a-toolbar row">
    <div class="btn-group btn-group-small pull-right hidden-xs">
        <a href="<?php echo JRoute::_('index.php?option=com_osma&view=chiamate'); ?>" class="btn btn-warning">
            <i class="fa fa-chevron-left"></i> <?php echo "Indietro"; ?>
        </a>
        <?php if ($this->chiamata) : ?>
            <button class="btn print" data-id='<?php echo $this->chiamata->idChiamata ?>'><i class="fa fa-print"
                                                                                             aria-hidden="true"></i> <?php echo "Stampa"; ?>
            </button>
        <?php endif; ?>
        <?php if ($canEdit) { ?>
            <button class="btn btn-danger elimina"><i class="fa fa-trash"
                                                      aria-hidden="true"></i> <?php echo "Elimina"; ?></button>
            <button class="btn btn-primary submitMezzoForm"><i class="fa fa-floppy-o"></i> <?php echo "Salva"; ?>
            </button>
        <?php } ?>
    </div>
    <div class="btn-group btn-group-small pull-right col-xs-12 visible-xs">
        <a href="<?php echo JRoute::_('index.php?option=com_osma&view=mezzi'); ?>"
           class="btn btn-warning col-xs-3">
            <i class="fa fa-chevron-left"></i> <?php echo "Indietro"; ?>
        </a>

        <?php if ($canEdit) { ?>
            <button class="btn btn-danger elimina col-xs-3"><i class="fa fa-trash"
                                                               aria-hidden="true"></i> <?php echo "Elimina"; ?>
            </button>
            <button class="btn btn-primary submitMezzoForm col-xs-3"><i
                        class="fa fa-floppy-o"></i> <?php echo "Salva"; ?></button>
        <?php } ?>
    </div>
</div>
<div class="panel panel-default main-panel">
    <div class="panel-heading" style="display:flex;align-items:center;">
        <h3 class="panel-title">Mezzo</h3>
    </div>

    <div class="panel-body">
        <div class="row">
            <form method="post"
                  action="<?php echo JRoute::_('index.php?option=com_osma&view=mezzo&task=mezzi.salva%ì&format=raw'); ?>"
                  id="mezzoForm" name="mezzoForm">
                <fieldset class='t3a-form'>
                    <div class='field col-sm-3 col-md-3 col-xs-6'>
                        <label>Marca</label>
                        <input type="text" name="marca" id="marca" class="form-control"
                               value="<?php echo $this->mezzo->marca; ?>">
                    </div>
                    <div class='field col-sm-3 col-md-3 col-xs-6'>
                        <label>Modello</label>
                        <input type="text" name="modello" id="modello" class="form-control"
                               value="<?php echo $this->mezzo->modello; ?>">
                    </div>
                    <div class='field col-sm-3 col-md-3 col-xs-6'>
                        <label>Targa</label>
                        <input type="text" name="targa" id="targa" class="form-control"
                               value="<?php echo $this->mezzo->targa; ?>">
                    </div>
                    <div class='field col-sm-3 col-md-3 col-xs-6'>
                        <label>Rimborso ACI</label>
                        <input type="text" name="rimborso" id="rimborso" class="form-control"
                               value="<?php echo $this->mezzo->rimborso; ?>">
                    </div>
                    <div class='field col-sm-3 col-md-3 col-xs-6'>
                        <label>Scadenza Bollo</label>
                        <div class='input-group date' id="date">
                            <input type='text' class="form-control"
                                   id='scadenzaBollo' <?php echo($canEdit ? "" : "disabled='disabled'") ?>
                                   name="scadenzaBollo"
                                   value="<?php echo(strtotime($this->mezzo->scadenzaBollo) > 0 ? date("d/m/Y", strtotime($this->mezzo->scadenzaBollo)) : "") ?>"/>
                            <span class="input-group-addon">
                                    <span class="glyphicon glyphicon-calendar"></span>
                                </span>
                        </div>
                    </div>
                    <div class='field col-sm-3 col-md-3 col-xs-6'>
                        <label>Scadenza Assicurazione</label>
                        <div class='input-group date' id="date">
                            <input type='text' class="form-control"
                                   id='scadenzaAssicurazione' <?php echo($canEdit ? "" : "disabled='disabled'") ?>
                                   name="scadenzaAssicurazione"
                                   value="<?php echo(strtotime($this->mezzo->scadenzaAssicurazione) > 0 ? date("d/m/Y", strtotime($this->mezzo->scadenzaAssicurazione)) : "") ?>"/>
                            <span class="input-group-addon">
                                    <span class="glyphicon glyphicon-calendar"></span>
                                </span>
                        </div>
                    </div>
                    <div class='field col-sm-3 col-md-3 col-xs-6'>
                        <label>Scadenza Revisione</label>
                        <div class='input-group date' id="date">
                            <input type='text' class="form-control"
                                   id='scadenzaRevisione' <?php echo($canEdit ? "" : "disabled='disabled'") ?>
                                   name="scadenzaRevisione"
                                   value="<?php echo(strtotime($this->mezzo->scadenzaRevisione) > 0 ? date("d/m/Y", strtotime($this->mezzo->scadenzaRevisione)) : "") ?>"/>
                            <span class="input-group-addon">
                                    <span class="glyphicon glyphicon-calendar"></span>
                                </span>
                        </div>
                    </div>
                    <div class='field col-md-3 col-sm-6 col-xs-12'>
                        <label>Note</label>
                        <textarea <?php echo($canEdit ? "" : "disabled='disabled'") ?>  class="form-control" name="note"
                                                                                        id="note"
                                                                                        rows="6"><?php echo $this->mezzo->note; ?></textarea>
                    </div>
                </fieldset>
                <?php echo JHtml::_('form.token'); ?>
                <input id="id" name="id" value="<?php echo JRequest::getVar('id'); ?>" type="hidden"/>
                <input type="hidden" value="<?php echo count($this->rifornimenti); ?>" name="nRifornimenti"
                       id="nRifornimenti"/>
                <input type="hidden" value="<?php echo $this->kmFinaliRiferimento; ?>" name="kmFinaliRiferimento"
                       id="kmFinaliRiferimento"/>
            </form>
        </div>
        <?php $nrRif=count($this->rifornimenti);?>
        <?php if ($this->mezzo->idMezzo) { ?>
            <div class="row" style="margin-top: 30px;">
                <p class="col-md-9">Ricordati di salvare dopo aver inserito i rifornimenti.</p>
                <?php if (osmaHelper::getAccessLevel() == COM_OSMA_AL_ADMIN) { ?>
                    <div class="text-right col-md-3" style="display: flex;justify-content: flex-end;">
                        <a href="/index.php?option=com_osma&task=mezzi.exportRifornimenti&format=raw&Itemid=618&idMezzo=<?php echo $this->mezzo->idMezzo;?>" class="btn btn-sm btn-primary export">
                            <span class="fa fa-external-link"></span> Esporta in excel
                        </a>
                        <button class="btn btn-success btn-sm aggiungi"><span
                                    class="glyphicon fa fa-plus-circle"></span> <?php echo "Aggiungi rifornimento"; ?>
                        </button>
                    </div>
                <?php } ?>
            </div>
            <div class="rifornimenti-group">
                <?php foreach ($this->rifornimenti as $i=>$rif): ?>
                    <form name='rifornimentoForm' id='rifornimentoForm'>
                        <fieldset class='t3a-form'>
                            <input type="hidden" value="<?php echo $rif->idMezzo;?>" name="rifornimento[idMezzo]" id="idMezzo"/>
                            <input type="hidden" value="<?php echo $rif->idRifornimento;?>" name="rifornimento[idRifornimento]" id="idRifornimento"/>
                            <div class="panel panel-warning">
                                <div class="panel-heading" style="display:flex;align-items:center;">
                                    <h3 class="panel-title col-md-6">Rifornimento nr.<?php echo $nrRif; ?></h3>
                                    <div class="col-md-6 text-right">
                                        <button class="btn btn-warning btn-sm saveRifornimento"
                                                data-loading-text="<i class=\'fa fa-circle-o-notch fa-spin\'></i> Salvando...">
                                            <span class="glyphicon glyphicon-floppy-open"></span> Salva
                                        </button>
                                        <button class="btn btn-danger btn-sm removeRifornimento"><span
                                                    class="glyphicon glyphicon-remove"></span> Rimuovi rifornimento
                                        </button>
                                    </div>
                                </div>
                                <div class="panel-body">
                                    <div class="row">
                                        <div class="col-md-3 field ">
                                            <label>KM iniziali:</label>
                                            <input type="text"  name="rifornimento[kmIniziali]"
                                                   class="form-control" value="<?php echo $rif->kmIniziali;?>"/>
                                        </div>
                                        <div class="col-md-3 field">
                                            <label>KM finali:</label>
                                            <input type="text"  name="rifornimento[kmFinali]"
                                                   class="form-control" value="<?php echo $rif->kmFinali;?>"/>
                                        </div>
                                        <div class="col-md-3 field">
                                            <label>Litri:</label>
                                            <input type="text"  name="rifornimento[litri]"
                                                   class="form-control" value="<?php echo $rif->litri; ?>"/>
                                        </div>
                                        <div class="col-md-3 field">
                                            <label>Importo:</label>
                                            <input type="text"  name="rifornimento[importo]"
                                                   class="form-control" value="<?php echo $rif->importo; ?>"/>
                                        </div>
                                    </div>
                                </div>
                        </fieldset>
                    </form>
                <?php $nrRif--;?>
                <?php endforeach; ?>
            </div>
        <?php } ?>
    </div>
</div>
