<?php
defined('_JEXEC') or die('Restricted access');
?>
<div class="t3a-toolbar row">
    <div class="clearfix hidden-xs flex" style="align-items: center;">
        <?php echo $this->loadTemplate('form'); ?>
    </div>
    <div class="visible-xs col-xs-12 text-center"style="padding-top: 15px; padding-bottom: 15px">
        <a href="#filter-collapse" data-toggle="collapse" role="button" aria-expanded="false" aria-controls="filter-collapse"><i class="glyphicon glyphicon-filter"></i> Azioni e filtri</a>        
    </div>
    <div class="col-xs-12 collapse" id="filter-collapse">
        <?php echo $this->loadTemplate('form'); ?>
    </div>
</div>

<form action="<?php echo JRoute::_('index.php?option=com_osma&view=modelli'); ?>" method="post" id="adminForm" class="form-validate" name="modelliForm">
    <div class="panel panel-default main-panel">
        <div class="panel-heading">
            <h3 class="panel-title">Anagrafica Modelli</h3>
        </div>
        <div class="panel-body">
            <div class="table-responsive">
                <table class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>Modello</th>
                            <th>Marca</th>
                            <th>Tipologia</th>
                            <th>Pubblicato</th>
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                            <td colspan="5" class="t3a-pagination">
                                <div class="col-md-6 text-left"><?php echo $this->pagination->getListFooter(); ?></div>
                                <div class="col-md-6 text-right">Nr. Risultati: <?php echo $this->pagination->getLimitBox(); ?></div>
                            </td>
                        </tr>
                    </tfoot>
                    <tbody>
                        <?php if (!empty($this->modelli)) { ?>
                            <?php $i = 0; ?>
                            <?php foreach ($this->modelli as $i => $modello) { ?>
                                <?php $checked = JHTML::_('grid.id', $i++, $modello->idModello); ?>
                                <tr>
                                    <td align="center"><?php echo $checked; ?></td>
                                    <td class="modello<?php echo $modello->idModello ?>" data-modello="<?php echo $modello->modello; ?>" data-sigla="<?php echo $modello->siglaRapportino; ?>"><?php echo $modello->modello; ?></td>
                                    <td class="marca<?php echo $modello->idModello ?>" data-marca="<?php echo $modello->idMarca; ?>"><?php echo $modello->marca; ?></td>
                                    <td class="tipo<?php echo $modello->idModello ?>" data-tipo="<?php echo $modello->idTipologia; ?>"><?php echo $modello->tipologia; ?></td>
                                    <td class="center"><?php if ($modello->published) { ?><span class="glyphicon glyphicon-ok-circle green"></span><?php } else { ?><span class="glyphicon glyphicon-ban-circle orange"></span><?php } ?></td>
                                </tr>
                            <?php } //end foreach ?>
                            <? }else{ ?>
                        <td colspan="5">Nessun modello inserito.</td>
                    <?php } //end if empty?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <input type="hidden" name="task" value=""/>
    <input type="hidden" name="boxchecked" value="0"/>
    <?php echo JHtml::_('form.token'); ?>
</form>
<div class="modal fade bs-example-modal-lg" id="addModello" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close chiudi-btn" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="myModalLabel">Dati Modello</h4>
            </div>
            <div class="modal-body">
                <form id="addModelloForm" class="addModelloForm">
                    <div class="panel panel-primary">
                        <div class="panel-heading">
                            <h3 class="panel-title">Dati Modello</h3>
                        </div>
                        <div class="panel-body">
                            <div class="form-group col-md-12">
                                <input id="dataModello" type="text" class="obb modello form-control" name="dataToSave" placeholder="Modello" value=""/>
                                <span class="hidden help-block">Inserisci un valore</span>
                            </div>
                            <div class="form-group col-md-12">
                                <input id="siglaRapportino" type="text" class="obb marca form-control" name="siglaRapportino" placeholder="Sigla Rapportino" value=""/>
                                <span class="hidden help-block">Inserisci un valore</span>
                            </div>
                        </div>
                    </div>
                    <div class="panel panel-warning">
                        <div class="panel-heading">
                            <h3 class="panel-title">Marca</h3>
                        </div>
                        <div class="panel-body">
                            <div class="form-group col-md-12">
                                <select id="marca" name="marca" data-placeholder="Associa alla marca" class="chosen-select marca-select" tabindex="17" style="width:100%;">

                                </select>
                            </div>
                        </div>
                    </div>
                    <div class="panel panel-warning panel-tipologia">
                        <div class="panel-heading">
                            <h3 class="panel-title">Tipologia</h3>
                        </div>
                        <div class="panel-body">
                            <div class="form-group col-md-12">
                                <select id="tipologia" name="tipologia" data-placeholder="Associa alla tipologia" class="chosen-select tipologia-select" tabindex="17" style="width:100%;">

                                </select>
                            </div>
                        </div>
                    </div>
                    <input type="hidden" name="id" value="0" id="id" />
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default chiudi-btn" >Chiudi</button>
                <button type="button" class="btn btn-primary salvabtn">Salva</button>
            </div>
        </div>
    </div>
</div>
<script type="text/javascript">
    var edit = 0; //campo che permette l'estrazione automatica delle marche e delle tipologie

//nuovo
    jQuery(document).on('click', '.nuovo', function (event) {
        event.preventDefault();
        edit = 0;
        jQuery('#addModello').modal();

        return false;
    });

//Modifica
    jQuery(document).on('click', '.modifica', function (event) {
        event.preventDefault();

        edit = 1;
        var checked = true;
        var idModello = "";
        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                checked = true;
                idModello = jQuery(value).val();
                return false;
            } else {
                checked = false;
            }
        });

        if (checked == true) {
            jQuery('#id').val(idModello);
            //setto modello con valore
            dataModello = jQuery(".modello" + idModello).data("modello");
            jQuery('#dataModello').val(dataModello);
            //setto sigla marca con valore
            siglaModello = jQuery(".modello" + idModello).data("sigla");
            jQuery('#siglaRapportino').val(siglaModello);

            //faccio chiamata ajax per popolare select marca
            idMarca = jQuery(".marca" + idModello).data("marca");
            jQuery.ajax({
                type: 'POST',
                url: 'index.php?option=com_osma&task=modelli.getMarche&format=raw&tmpl=component',
                data: {},
                dataType: 'json'
            }).done(function (data) {
                if (data == 'error') {

                } else {
                    //carico select tipologie
                    jQuery("#marca").html('');
                    if (data.length > 0) {
                        jQuery.each(data, function (idx, obj) {
                            jQuery("#marca").append('<option value="' + obj.idMarca + '">' + obj.marca + '</option>');
                        });
                        jQuery("#marca").val(idMarca);
                        jQuery("#marca").trigger("chosen:updated");
                    } else {
                        jQuery("#marca").html('');
                        jQuery("#marca").trigger("chosen:updated");
                        alert("Nessuna marca inserita!")
                    }
                }
            });

            //faccio chiamata ajax per popolare select tipologia
            idTipologia = jQuery(".tipo" + idModello).data("tipo");
            jQuery.ajax({
                type: 'POST',
                url: 'index.php?option=com_osma&task=modelli.getTipologie&format=raw&tmpl=component',
                data: {idMarca: idMarca},
                dataType: 'json'
            }).done(function (data) {
                if (data == 'error') {

                } else {
                    //carico select tipologie
                    jQuery("#tipologia").html('');
                    if (data.length > 0) {
                        jQuery.each(data, function (idx, obj) {
                            jQuery("#tipologia").append('<option value="' + obj.idTipologia + '">' + obj.tipologia + '</option>');
                        });
                        jQuery("#tipologia").val(idTipologia);
                        jQuery("#tipologia").trigger("chosen:updated");
                    } else {
                        jQuery("#tipologia").html('');
                        jQuery("#tipologia").trigger("chosen:updated");
                        alert("Nessuna tipologia associata alla marca selezionata!")
                    }
                }
            });

            jQuery('#addModello').modal();
        } else {
            var msg = {
                error: ['Seleziona un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//Pubblica
    jQuery(document).on('click', '.pubblica', function (event) {
        event.preventDefault();

        var i = 0;
        var ids = [];

        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                ids.push(jQuery(value).val());
            }
        });
        if (ids.length != 0) {
            //ajax call
            var url = "index.php?option=com_osma&task=modelli.pubblica&format=raw";
            jQuery.ajax({
                type: "POST",
                url: url,
                data: {ids: ids, type: 6
                }
            }).done(function (result) {
                var msg = {
                    success: ['Pubblicazione degli elementi selezionati avvenuta con successo.']
                };
                Joomla.renderMessages(msg);
                setInterval(function () {
                    refresh()
                }, 3000);
            });
        } else {
            var msg = {
                error: ['Seleziona almeno un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//Sospendi
    jQuery(document).on('click', '.sospendi', function (event) {
        event.preventDefault();

        var i = 0;
        var ids = [];

        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                ids.push(jQuery(value).val());
            }
        });
        if (ids.length != 0) {
            //ajax call
            var url = "index.php?option=com_osma&task=modelli.sospendi&format=raw";
            jQuery.ajax({
                type: "POST",
                url: url,
                data: {ids: ids, type: 6
                }
            }).done(function (result) {
                var msg = {
                    success: ['Sospensione degli elementi selezionati avvenuta con successo.']
                };
                Joomla.renderMessages(msg);
                setInterval(function () {
                    refresh()
                }, 3000);
            });
        } else {
            var msg = {
                error: ['Seleziona almeno un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//Rimuovi
    jQuery(document).on('click', '.rimuovi', function (event) {
        event.preventDefault();

        var i = 0;
        var ids = [];

        jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
            if (jQuery(value).attr("checked")) {
                ids.push(jQuery(value).val());
            }
        });
        if (ids.length != 0) {
            //chiedo conferma della Rimozione
            var r = confirm("Sei sicuro di voler eliminare gli elementi selezionati?");
            if (r == true) {
                var url = "index.php?option=com_osma&task=modelli.rimuovi&format=raw";
                jQuery.ajax({
                    type: "POST",
                    url: url,
                    data: {ids: ids, type: 6
                    }
                }).done(function (result) {
                    jQuery.each(jQuery("input[name='cid[]']"), function (index, value) {
                        if (jQuery(value).attr("checked")) {
                            el = jQuery(value);
                            el.parent().parent().remove();
                        }
                    });
                    var msg = {
                        success: ['Rimozione degli elementi selezionati avvenuta con successo.']
                    };
                    Joomla.renderMessages(msg);
                    setInterval(function () {
                        refresh()
                    }, 3000);
                });
            } else {
                return false;
            }
        } else {
            var msg = {
                error: ['Seleziona almeno un elemento nella lista.']
            };
            Joomla.renderMessages(msg);
        }
        return false;
    });

//salvataggio dati modello
    jQuery(document).on('click', '.salvabtn', function (event) {
        event.preventDefault();
        var inviaForm = 0;

        // //controllo errori form
        var modello = jQuery('.modello').val();


        if (modello == "") {
            jQuery('.modello').parent().addClass("has-error");
            jQuery('.modello').parent().find('span.help-block').removeClass("hidden");
            inviaForm = 0;
        } else {
            jQuery('.modello').parent().removeClass("has-error");
            jQuery('.modello').parent().addClass("has-success");
            jQuery('.modello').parent().find('span.help-block').addClass("hidden");
            inviaForm = 1
        }

        if (inviaForm == 1) {
            var addModelloformfield = jQuery('#addModelloForm').serialize();

            jQuery.ajax({
                type: 'POST',
                url: 'index.php?option=com_osma&task=modelli.salva&format=raw&tmpl=component&type=3',
                data: addModelloformfield,
                dataType: 'html'
            }).done(function (data) {
                if (data == 'error') {
                    jQuery('#addModello').modal('toggle');
                    var msg = {
                        error: ['Errore nel salvataggio dei dati.']
                    };
                    Joomla.renderMessages(msg);
                    setInterval(function () {
                        refresh()
                    }, 3000);
                } else {
                    jQuery('#addModello').modal('toggle');
                    var msg = {
                        success: ['Salvataggio dati avvenuto con successo.']
                    };
                    Joomla.renderMessages(msg);
                    setInterval(function () {
                        refresh()
                    }, 3000);
                }
            });
        }

        return false;
    });

//refresh page dopo aver mostrato il messaggio di salvataggio
    function refresh() {
        window.location.reload(true);
    }
//inizializzazione chosen marca select
    jQuery(document).ready(function ($) {
        jQuery(".chosen-select").chosen({width: "100%"});
    });

//carico marche quando scrivo un modello
    jQuery(document).on('change', '.modello', function (event) {
        var modello = jQuery(this).val();
        if (modello != "") {
            if (edit == 0) {
                jQuery.ajax({
                    type: 'POST',
                    url: 'index.php?option=com_osma&task=modelli.getMarche&format=raw&tmpl=component',
                    data: {},
                    dataType: 'json'
                }).done(function (data) {
                    if (data == 'error') {

                    } else {
                        //carico select tipologie
                        jQuery("#marca").html('');
                        if (data.length > 0) {
                            jQuery.each(data, function (idx, obj) {
                                jQuery("#marca").append('<option value="' + obj.idMarca + '">' + obj.marca + '</option>');
                            });
                            jQuery("#marca").trigger("chosen:updated");
                        } else {
                            jQuery("#marca").html('');
                            jQuery("#marca").trigger("chosen:updated");
                            alert("Nessuna marca inserita!")
                        }
                    }
                });
            }
        } else {
            jQuery("#marca").html('');
            jQuery("#marca").trigger("chosen:updated");
            jQuery("#tipologia").html('');
            jQuery("#tipologia").trigger("chosen:updated");
        }
    });

//carico tipologie dopo aver selezionato marca
    jQuery(document).on('change', '.marca-select', function (event) {
        var idMarca = jQuery(this).val();

        jQuery.ajax({
            type: 'POST',
            url: 'index.php?option=com_osma&task=modelli.getTipologie&format=raw&tmpl=component',
            data: {idMarca: idMarca},
            dataType: 'json'
        }).done(function (data) {
            if (data == 'error') {

            } else {
                //carico select tipologie
                jQuery("#tipologia").html('');
                if (data.length > 0) {
                    jQuery.each(data, function (idx, obj) {
                        jQuery("#tipologia").append('<option value="' + obj.idTipologia + '">' + obj.tipologia + '</option>');
                    });
                    jQuery("#tipologia").trigger("chosen:updated");
                } else {
                    jQuery("#tipologia").html('');
                    jQuery("#tipologia").trigger("chosen:updated");
                    alert("Nessuna tipologia associata alla marca selezionata!")
                }
            }
        });
    });
//chiudi-btn
    jQuery(document).on('click', '.chiudi-btn', function (event) {
        event.preventDefault();

        jQuery('#dataModello').parent().removeClass("has-error");
        jQuery('#dataModello').parent().find('span.help-block').addClass("hidden");
        //azzero le select prima di chiudere il modal
        jQuery('#marca').find('option:first-child').prop('selected', true).end().trigger('chosen:updated');
        jQuery("#tipologia").html('');
        jQuery("#tipologia").trigger("chosen:updated");
        jQuery('#addModello').modal('toggle');


        return false;
    });
</script>
