<div class="panel panel-primary">
    <div class="panel-heading">
        <h3 class="panel-title">Dati Gestore</h3>
    </div>
    <div class="panel-body">
        <b>Ragione Sociale:</b> <?php echo $data->ragioneSociale; ?><br><br>
        <b>Indirizzo:</b> <?php echo $data->indirizzo; ?><br><br>
        <b>Comune:</b> <?php echo $data->comune; ?><br><br>
        <b>Provincia:</b> <?php echo $data->provincia; ?><br><br>
        <b>CAP:</b> <?php echo $data->cap; ?><br><br>
        <b>Partita IVA:</b> <?php echo $data->piva; ?><br><br>
        <b>Codice fiscale:</b> <?php echo $data->cf; ?><br><br>
        <b>Nr. REA:</b> <?php echo $data->nrRea; ?><br><br>
        <b>Nr. punto vendita:</b> <?php echo $data->nrPuntoVendita; ?><br><br>
        <b>Cliente associato:</b> 
        <?php foreach ($clienti as $cliente) { ?>
            <?php if ($cliente->idCliente == $data->idCliente) { ?>
                <?php echo $cliente->ragioneSociale; ?>
            <?php } ?>
        <?php } ?><br><br>
        <b>Compagnia associata:</b> 
        <?php foreach ($compagnie as $compagnia) { ?>
            <?php if ($compagnia->idCompagnia == $data->idCompagnia) { ?>
                <?php echo $compagnia->compagnia; ?>
            <?php } ?>
        <?php } ?>
    </div>
</div>
<div class="panel panel-primary">
    <div class="panel-heading">
        <h3 class="panel-title">Dati Contatti</h3>
    </div>
    <div class="panel-body contatti-group">
        <?php foreach ($contatti as $contatto) { ?>
            <b>Riferimento:</b> <?php echo $contatto->riferimento; ?> <?php if ($contatto->email) { ?>- <b>Email:</b> <?php echo $contatto->email; ?> <?php } ?><?php if ($contatto->telefono) { ?>- <b>Telefono:</b> <?php echo $contatto->telefono; ?> <?php } ?><br><br>
        <?php } ?>
    </div>
</div>
<div class="panel panel-primary">
    <div class="panel-heading">
        <h3 class="panel-title">Dati Cisterne</h3>
    </div>
    <div class="panel-body cisterne-group">
        <?php foreach ($cisterne as $cisterna) { ?>
            <b>Numero cisterna:</b> <?php echo $cisterna->nrCisterna; ?> 
            <?php if ($cisterna->capienza) { ?>
                - <b>Capienza:</b> <?php echo $cisterna->capienza; ?> 
            <?php } ?>
            <?php if ($cisterna->idProdottoErogato) { ?>
                - <b>Prodotto erogato:</b> 
                <?php foreach ($prodotti as $prodotto) { ?>
                    <?php if ($cisterna->idProdottoErogato == $prodotto->idProdottoErogato) { ?>
                        <?php echo $prodotto->prodottoErogato; ?>
                    <?php } ?>
                <?php } ?>
            <?php } ?>
            - <b>Presenza intercapedine:</b> <?php echo ($cisterna->presenza ? "Si" : "No" ) ?><br><br>
        <?php } ?>
    </div>
</div>
