<?php
// No direct access to this file

error_reporting(E_ALL);

class OsmaViewPreventivatore extends JViewLegacy {

    function display($tpl = null) {

        $this->items = $this->get("Items");

        $this->title = JText::_("Preventivatore");

        switch (JRequest::getVar("layout") ? JRequest::getVar("layout") : "default") {
            case 'preventivo':
                $this->preventivo = $this->items;
                $model = $this->getModel('Preventivatore');
                if (JRequest::getVar("idPreventivo") || $this->preventivo) {
                    $this->chiamata = $model->getChiamata($this->preventivo->idChiamata);
                    $this->numeroPreventivo = str_pad($this->preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) . "/" . date("Y", strtotime($this->preventivo->inserted));
                } elseif (JRequest::getVar("idChiamata")) {
                    $this->chiamata = $model->getChiamata(JRequest::getVar("idChiamata"));

                    $this->numeroPreventivo = str_pad($model->getNextIdPreventivo(), 6, "0", STR_PAD_LEFT) . "/" . date("Y");
                }
                $this->capitoli = $this->get("Capitolato");
                $this->preventivi = $this->get("Preventivi");


                $this->listini_filter= $this->get('Listini');
                $this->capitoli_filter= $this->get('Capitoli');
                $this->famiglie_filter= $this->get('Famiglie');
                $this->voci_filter= $this->get('Voci');
                $this->sottovoci_filter= $this->get('SottoVoci');


                break;
            case 'default':
                JFactory::getDocument()->addStyleSheet(JURI::base() . 'components/com_osma/assets/css/view-preventivatore.default.css?ver=' . time());
                break;
        }

        //JFactory::getDocument()->addScript(JURI::base() . 'components/com_osma/assets/js/view-preventivatore.js?ver=' . COM_OSMA_VER, "text/javascript");

        if (count($errors = $this->get('Errors'))) {
            JError::raiseError(500, implode('<br />', $errors));
            return false;
        }

        parent::display($tpl);
    }

    function option_sottocapitolo($item, $before, $onlyparent = false) {
        if (!$item->sottocapitoli) {
            return;
        }

        foreach ($item->sottocapitoli as $subitem) {
            if ($onlyparent && trim($subitem->um) == "") {
                ?><option value="<?php echo $subitem->idCapitolo ?>"><?php echo $before . "." . $subitem->codiceCapitolo . ": " . $subitem->nome ?></option><?php
            } elseif (!$onlyparent) {
                ?><option value="<?php echo $subitem->idCapitolo ?>"><?php echo $before . "." . $subitem->codiceCapitolo . ": " . $subitem->nome ?></option><?php
            }
            $this->option_sottocapitolo($subitem, "&nbsp;&nbsp;&nbsp;&nbsp;" . $before . "." . $subitem->codiceCapitolo, $onlyparent);
        }
    }

}
